local scale = 1
local showclock = true	
local mediafolder ="Interface\\AddOns\\Ryv's Minimap\\media\\"
local font = mediafolder.."Ronda.ttf"
local fontSize = 8
local fontFlag = "OUTLINE MONOCHROME"
local mailicon = mediafolder.."Mail"
local texture = "Interface\\Buttons\\WHITE8x8.tga"
local backdrop = {edgeFile = texture, edgeSize = 1}
local bordercolor = {0/255, 0/255, 0/255}
local backdropcolor = {0/255, 0/255, 0/255}
local ClassColoredBorder = false
local _, class = UnitClass('player')
local color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]	
MinimapCluster:EnableMouse (false)

position = "TOPRIGHT"
position_x = -6.5       		
position_y = -6.5      		
-- Hold SHIFT to move
-----------------------
--make it pretty-
-----------------------
Minimap:SetMaskTexture(texture)
Minimap:SetFrameStrata("BACKGROUND")
Minimap:ClearAllPoints()
Minimap:SetPoint(position, UIParent, position_x, position_y)
Minimap:SetScale(scale)

QueueStatusMinimapButton:SetClampedToScreen(true)

BorderFrame = CreateFrame("Frame", nil, Minimap)
BorderFrame:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -1, 1)
BorderFrame:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 1, -1)	
BorderFrame:SetBackdrop(backdrop)
if not ClassColoredBorder then
	BorderFrame:SetBackdropBorderColor(unpack(bordercolor))
else
	BorderFrame:SetBackdropBorderColor(color.r, color.g, color.b)
end	
BorderFrame:SetBackdropColor(unpack(backdropcolor))
BorderFrame:SetFrameLevel(0)
-------------------------
--Get rid of the oogly-
-------------------------
MinimapBorder:Hide()
MinimapBorderTop:Hide()
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
MiniMapVoiceChatFrame:Hide()
GameTimeFrame:Hide()
MinimapZoneTextButton:Hide()
MiniMapTracking:Hide()
MiniMapMailBorder:Hide()
MinimapNorthTag:SetAlpha(0)
MiniMapInstanceDifficulty:SetAlpha(1)
GuildInstanceDifficulty:SetAlpha(1)
--------------------------
--Instance difficulty flag 
--------------------------

local rd = CreateFrame("Frame", nil, Minimap)
rd:SetSize(24, 8)
rd:RegisterEvent("PLAYER_ENTERING_WORLD")
rd:RegisterEvent("PLAYER_DIFFICULTY_CHANGED")
rd:RegisterEvent("GUILD_PARTY_STATE_UPDATED")

local rdt = rd:CreateFontString(nil, "OVERLAY")
rdt:SetPoint("TOP", Minimap, "TOPLEFT", 8, -3)
rdt:SetFont(font, fontSize, fontFlag)

rd:SetScript("OnEvent", function()
	local _, _, difficulty, _, maxPlayers = GetInstanceInfo()

	if difficulty == 0 then
		rdt:SetText("")
	elseif maxPlayers == 3 then
		rdt:SetText("3")
	elseif difficulty == 1 then
		rdt:SetText("5")
	elseif difficulty == 2 then
		rdt:SetText("5H")
	elseif difficulty == 3 then
		rdt:SetText("10")
	elseif difficulty == 4 then
		rdt:SetText("25")
	elseif difficulty == 5 then
		rdt:SetText("10H")
	elseif difficulty == 6 then
		rdt:SetText("25H")
	elseif difficulty == 7 then
		rdt:SetText("LFR")
	elseif difficulty == 8 then
		rdt:SetText("5CM")
	elseif difficulty == 9 then
		rdt:SetText("40")
	end

	if GuildInstanceDifficulty:IsShown() then
		rdt:SetTextColor(color.r, color.g, color.b)
	else
		rdt:SetTextColor(color.r, color.g, color.b)
	end
end)
--------------------------
--Zone and clockity-clock-
--------------------------
--local zoneTextFrame = CreateFrame("Frame", nil, UIParent)
--zoneTextFrame:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, zoneTextYOffset)
--zoneTextFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, zoneTextYOffset)
--zoneTextFrame:SetHeight(19)
--MinimapZoneText:SetParent(zoneTextFrame)
--MinimapZoneText:SetPoint("LEFT", 2, 1)
--MinimapZoneText:SetPoint("RIGHT", -2, 1)
--MinimapZoneText:SetFont(font, fontSize, fontFlag)
if showclock then
	LoadAddOn('Blizzard_TimeManager')
	local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
	clockFrame:Hide()
	clockTime:Show()
	clockTime:SetFont(font, fontSize, fontFlag)
        clockTime:SetTextColor(color.r, color.g, color.b)
	TimeManagerClockButton:SetPoint("BOTTOM", Minimap, 0, -8.5)
else
	LoadAddOn('Blizzard_TimeManager')
	TimeManagerClockButton:Hide()	
end		
---------------------------
--If you want to boogie, you've got to move!--
---------------------------
Minimap:SetMovable(true)
Minimap:SetUserPlaced(true)
Minimap:SetScript("OnMouseDown", function()
    if (IsShiftKeyDown()) then
        Minimap:ClearAllPoints()
        Minimap:StartMoving()
    end
end)

Minimap:SetScript('OnMouseUp', function(self, button)
Minimap:StopMovingOrSizing()
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (Minimap:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)
---------------------------
--Shift the must haves-
---------------------------
QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint("BOTTOMLEFT", Minimap, -3, 0)
QueueStatusMinimapButton:SetScale(1)
QueueStatusMinimapButton:SetFrameLevel(4)
QueueStatusMinimapButtonBorder:Hide()
MiniMapWorldMapButton:Hide()
MiniMapInstanceDifficulty:Hide()
MiniMapInstanceDifficulty.Show = function() end
GuildInstanceDifficulty:Hide()
GuildInstanceDifficulty.Show = function() end
function UpdateLFG()
	MiniMapLFGFrame:ClearAllPoints()
	MiniMapLFGFrame:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", -0.5, -5)
        MiniMapLFGFrame:SetScale(0.9)
    QueueStatusMinimaputton:ClearAllPoints()
    QueueStatusMinimapButton:SetPoint(position, MiniMapLFGFrame, position)
end
QueueStatusMinimapButtonBorder:SetAlpha(0)
DropDownList1:SetClampedToScreen(true)

MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("BOTTOMRIGHT", Minimap, 4, -8)
MiniMapMailIcon:SetTexture(mailicon)
----------------------------
--Zoom zoom!
----------------------------
Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(self, z)
	local c = Minimap:GetZoom()
	if(z > 0 and c < 5) then
		Minimap:SetZoom(c + 1)
	elseif(z < 0 and c > 0) then
		Minimap:SetZoom(c - 1)
	end
end)
-----------------------------
--Extra B-E-A-utiful stuff-
-----------------------------
SlashCmdList.RELOADUI = ReloadUI
SLASH_RELOADUI1 = "/rl"
SlashCmdList.TICKET = ToggleHelpFrame
SLASH_TICKET1 = "/gm"

SubZoneTextString:SetFont(font, 8, "MONOCHROMEOUTLINE")
ZoneTextString:SetFont(font, 8, "MONOCHROMEOUTLINE")
PVPInfoTextString:SetFont(font, 8, "MONOCHROMEOUTLINE")
PVPArenaTextString:SetFont(font, 8, "MONOCHROMEOUTLINE")
ZoneTextString:SetPoint("CENTER", Minimap, "CENTER", 0, 0)
SubZoneTextString:SetPoint("CENTER", ZoneTextString, "CENTER", 0, -3)
